package com.vip.sdk.utils_lib.thread;

import android.os.Process;
import android.text.TextUtils;

/**
 * Author: rongjinsong(jason01.rong@vipshop.com)
 * Date: 2015-05-20
 * Time: 17:14
 */
public abstract class ProvityRunnable implements Runnable, Comparable<ProvityRunnable> {
    private int mProvity = Process.THREAD_PRIORITY_BACKGROUND;
    private String mName;
    public ProvityRunnable(){

    }

    public ProvityRunnable(String name){
        mName = name;
    }


    @Override
    public final int compareTo(ProvityRunnable another) {
        return this.mProvity > another.mProvity ? 1
                : this.mProvity < another.mProvity ? -1 : 0;
    }

    @Override
    public final void run() {
        Process.setThreadPriority(mProvity);
        if (!TextUtils.isEmpty(mName)) {
            Thread.currentThread().setName(mName);
        }
        job();
        afterJob();
    }

    public abstract void job();
    public int getProvity() {
        return mProvity;
    }

    public void afterJob(){
    	
    }
    public ProvityRunnable buildProvity(int provity) {
        mProvity = provity;
        return this;
    }
    

    public ProvityRunnable buildName(String name) {
        mName = name;
        return this;
    }

    public String getName() {
        return mName;
    }
    
}
